; encoder.asm from rs_kbd project: rotary encoder routines
; 
; Copyright 2016,2017 Mihai Gaitos, mihaig@hawk.ro
; 
; Permission is hereby granted, without written agreement and without
; license or royalty fees, to use, copy, modify, and distribute this
; software and its documentation for any purpose, provided that the
; above copyright notice and the following two paragraphs appear in
; all copies of this software.
; 
; IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE TO ANY PARTY FOR
; DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
; ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN
; IF THE COPYRIGHT HOLDER HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
; DAMAGE.
; 
; THE COPYRIGHT HOLDER SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING,
; BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
; FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
; ON AN "AS IS" BASIS, AND THE COPYRIGHT HOLDER HAS NO OBLIGATION TO
; PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.

; ENCODER PROCEDURES

ENC_INIT
		MOVLW	ENC11	; (usually this is the starting position)
		MOVWF	PRVI
		CLRF	ENCR
		CLRF	EST
		RETURN

CHKENC
		CLRF	ENCR	; start by clearing encoder result
		ANDLW	ENCMASK
		MOVWF	CRTIN	; save current input
		XORWF	PRVI,W
		BTFSC	STATUS,Z
		RETURN			; if CRTIN==PRVI then return
		MOVF	CRTIN,W
		MOVWF	PRVI
		MOVLW	ENCBASE>>8
		MOVWF	PCLATH
		MOVF	EST,W
		ANDLW	h'7'
		MOVWF	TMPW
		SWAPF	TMPW,W
		CALL	ENCBASE
		MOVWF	EST		; save machine state
		RETURN			; (result is now in ENCR)

CHKENC_ENDP

; ENCODER MACHINE
	ORG	ENCBASE
	ADDWF	PCL,F
	MOVF	CRTIN,W
	XORLW	ENC10
	BTFSC	STATUS,Z
	RETLW	H'1'
	MOVF	CRTIN,W
	XORLW	ENC01
	BTFSC	STATUS,Z
	RETLW	H'4'
	RETLW	H'7'

	ORG	ENCBASE+H'11'
	MOVF	CRTIN,W
	XORLW	ENC00
	BTFSC	STATUS,Z
	RETLW	H'2'
	MOVF	CRTIN,W
	XORLW	ENC11
	BTFSC	STATUS,Z
	RETLW	H'0'
	RETLW	H'7'

	ORG	ENCBASE+H'21'
	MOVF	CRTIN,W
	XORLW	ENC01
	BTFSC	STATUS,Z
	RETLW	H'3'
	MOVF	CRTIN,W
	XORLW	ENC10
	BTFSC	STATUS,Z
	RETLW	H'1'
	RETLW	H'7'

	ORG	ENCBASE+H'31'
	MOVF	CRTIN,W
	XORLW	ENC11
	BTFSC	STATUS,Z
	GOTO	EF1
	MOVF	CRTIN,W
	XORLW	ENC00
	BTFSC	STATUS,Z
	RETLW	H'2'
	RETLW	H'7'
EF1
	MOVLW	D'1'	; increase
	MOVWF	ENCR
	RETLW	H'0'

	ORG	ENCBASE+H'41'
	MOVF	CRTIN,W
	XORLW	ENC00
	BTFSC	STATUS,Z
	RETLW	H'5'
	MOVF	CRTIN,W
	XORLW	ENC11
	BTFSC	STATUS,Z
	RETLW	H'0'
	RETLW	H'7'

	ORG	ENCBASE+H'51'
	MOVF	CRTIN,W
	XORLW	ENC10
	BTFSC	STATUS,Z
	RETLW	H'6'
	MOVF	CRTIN,W
	XORLW	ENC01
	BTFSC	STATUS,Z
	RETLW	H'4'
	RETLW	H'7'

	ORG	ENCBASE+H'61'
	MOVF	CRTIN,W
	XORLW	ENC11
	BTFSC	STATUS,Z
	GOTO	EF2
	MOVF	CRTIN,W
	XORLW	ENC00
	BTFSC	STATUS,Z
	RETLW	H'5'
	RETLW	H'7'
EF2
	MOVLW	D'2'	; decrease
	MOVWF	ENCR
	RETLW	H'0'

	ORG	ENCBASE+H'71'
	MOVF	CRTIN,W
	XORLW	ENC11
	RETLW	H'0'
	RETLW	H'7'


	ORG	CHKENC_ENDP
