; procsc.asm from rs_kbd project:
;  AT Keyboard scancode processing, decoding and ASCII output.
; 
; Copyright 2016,2017 Mihai Gaitos, mihaig@hawk.ro
; 
; Permission is hereby granted, without written agreement and without
; license or royalty fees, to use, copy, modify, and distribute this
; software and its documentation for any purpose, provided that the
; above copyright notice and the following two paragraphs appear in
; all copies of this software.
; 
; IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE TO ANY PARTY FOR
; DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
; ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN
; IF THE COPYRIGHT HOLDER HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
; DAMAGE.
; 
; THE COPYRIGHT HOLDER SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING,
; BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
; FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
; ON AN "AS IS" BASIS, AND THE COPYRIGHT HOLDER HAS NO OBLIGATION TO
; PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.

		MOVF	CRT_OP,W
		SUBLW	OP_ASCII
		BTFSC	STATUS,Z
		GOTO	ASCII
; *** since we now have only ASCII and HEX, no need for further checking
;		MOVF	CRT_OP,W
;		SUBLW	OP_HEX
;		BTFSC	STATUS,Z
;		GOTO	HEX
;HEX
		MOVF	TMP_SC,W	; get current scancode
		CALL	PRNHEX2		; and "print" it

		MOVLW	H'FA'		; ACKnowledge
		XORWF	TMP_SC,W
		BTFSC	STATUS,Z
		GOTO	K_ACK

		GOTO	EOPSC

ASCII
		MOVF	TMP_SC,W	; get current scancode and check for special values
		SUBLW	H'F0'		; release
		BTFSC	STATUS,Z
		GOTO	K_RELEASE
		MOVF	TMP_SC,W
		SUBLW	H'12'		; left shift
		BTFSC	STATUS,Z
		GOTO	K_SHIFT
		MOVF	TMP_SC,W
		SUBLW	H'59'		; right shift
		BTFSC	STATUS,Z
		GOTO	K_SHIFT
		MOVF	TMP_SC,W
		SUBLW	H'14'		; left control
		BTFSC	STATUS,Z
		GOTO	K_CTRL
		MOVF	TMP_SC,W
		SUBLW	H'E0'		; special prefix
		BTFSC	STATUS,Z
		GOTO	K_SPECIAL
		MOVF	TMP_SC,W
		SUBLW	H'E1'		; special (pause) prefix
		BTFSC	STATUS,Z
		GOTO	K_SPECIAL
		MOVF	TMP_SC,W
		SUBLW	H'FE'		; resend request
		BTFSC	STATUS,Z
		GOTO	K_RESEND
		MOVF	TMP_SC,W
		SUBLW	H'FA'		; ACKnowledge
		BTFSC	STATUS,Z
		GOTO	K_ACK
		MOVF	TMP_SC,W
		SUBLW	H'58'		; CAPS
		BTFSC	STATUS,Z
		GOTO	K_CAPS
		MOVF	TMP_SC,W
		SUBLW	H'77'		; numlock
		BTFSC	STATUS,Z
		GOTO	K_NUM
		MOVF	TMP_SC,W
		SUBLW	H'83'		; F7 (WHY is F7's scancode 83h?! Only IBM knows)
		BTFSC	STATUS,Z
		GOTO	K_F7
		MOVF	TMP_SC,W
		SUBLW	H'84'		; SysRq
		BTFSC	STATUS,Z
		GOTO	K_SYSRQ
		MOVF	TMP_SC,W
		SUBLW	H'78'		; F11 - Fast typematic
		BTFSC	STATUS,Z
		GOTO	K_FAST
		MOVF	TMP_SC,W
		SUBLW	H'07'		; F12 - Normal typematic
		BTFSC	STATUS,Z
		GOTO	K_NRML

		BTFSC	TMP_SC,7
		GOTO	IGN_KEY		; ignore other scancodes above 80h

NORMAL_KEY
		MOVF	TMP_SC,W
		BTFSC	K_FLAGS,F_RELEASE
		GOTO	IGN_KEY		; if release flag was set ignore next key (special cases were already processed above)

SCPROC
; check CTRL
		BTFSS	K_FLAGS,F_CTRL
		GOTO	NO_CTRL
		MOVLW	H'1E'		; 2
		XORWF	TMP_SC,W	; for Ctrl+2(or Ctrl+@)
		BTFSC	STATUS,Z
		GOTO	SEND00		; will send 00h
		MOVLW	2
		MOVWF	PCLATH
		MOVF	TMP_SC,W
		CALL	SCTAB_CTRL
		GOTO	RTS

SEND00
		MOVLW	H'00'
		CALL	SENDCHR
		GOTO	EOPSC


NO_CTRL
; SHIFT+NUMLOCK (for RIGHT NUMERIC BLOCK)
		BCF		MYFLAGS,MFTMPBIT
		MOVLW	1<<MFTMPBIT
		BTFSC	K_FLAGS,F_SHIFT
		XORWF	MYFLAGS,F
		BTFSC	K_FLAGS,F_NUMLOCK
		XORWF	MYFLAGS,F
		BTFSS	MYFLAGS,MFTMPBIT
		GOTO	NO_NUM

; RIGHT NUMERIC
		MOVF	TMP_SC,W
		SUBLW	H'68'		; if <=68
		BTFSC	STATUS,C
		GOTO	NO_NUM
		MOVF	TMP_SC,W
		SUBLW	H'7D'		; if >7D
		BTFSS	STATUS,C
		GOTO	NO_NUM
; special table for RIGHT NUMERIC with NULOCK or SHIFT
		MOVLW	2
		MOVWF	PCLATH
		MOVLW	H'68'
		SUBWF	TMP_SC,W
		CALL	SCTABN
		GOTO	RTS
NO_NUM

;		SUBLW	H'F0'		; if scancode=F0 then ignore
;		BTFSC	STATUS,Z
;		GOTO	STIGN



		MOVLW	1		; prepare for table read (table at 100h)
		MOVWF	PCLATH
		MOVF	TMP_SC,W

		BTFSC	K_FLAGS,F_SHIFT
		ADDLW	H'80'		; if shift is on then add 80 to W then
		CALL	SCTABLE		; call table that returns with CHAR (ASCII) in W

		CLRF	PCLATH

		MOVWF	TMP_SC
		BTFSS	K_FLAGS,F_CAPSLOCK
		GOTO	SEND_UNCH	; if not CAPS LOCK send the original code

; the code below should do:
; if((c>=0x41 && c<=0x5a) || (c>=0x61 && c<=0x7a)) invert_case(c);
; that is required because Shift also lowers case from CAPS.
		SUBLW	H'40'		; if <=40 (41 = A)
		BTFSC	STATUS,C
		GOTO	SEND_UNCH	; send it as it is
		MOVF	TMP_SC,W
		SUBLW	H'7A'		; if >7A
		BTFSS	STATUS,C
		GOTO	SEND_UNCH
		MOVF	TMP_SC,W
		SUBLW	H'5A'		; if <=5A
		BTFSC	STATUS,C
		GOTO	CCC			; it will be processed (Change Char Case)
		MOVF	TMP_SC,W
		SUBLW	H'60'		; if <=60 (but >5a because of the above)
		BTFSC	STATUS,C
		GOTO	SEND_UNCH	; send unchanged
CCC							; process CAPS LOCK
		MOVF	TMP_SC,W
		XORLW	H'20'		; toggle CAPS bit in sent char
RTS
		XORLW	H'00'
		BTFSS	STATUS,Z	; send only if W!=0
		CALL	SENDCHR
		GOTO	EOPSC
SEND_UNCH
		MOVF	TMP_SC,W
		GOTO	RTS


IGN_KEY
		BCF		K_FLAGS,F_RELEASE
		GOTO	EOPSC

K_RELEASE
		BSF	K_FLAGS,F_RELEASE
		GOTO	EOPSC

K_SHIFT
		BTFSC	K_FLAGS,F_RELEASE	; check release flag
		GOTO	SHIFT_OFF			; if set then unset shift
SHIFT_ON							; else set shift
		BSF		K_FLAGS,F_SHIFT
		BCF		PORTB,UDLED			; and change LEDs
		BSF		PORTB,LRLED
		GOTO	EOPSC
SHIFT_OFF							; unset shift
		BCF		K_FLAGS,F_SHIFT
		BSF		PORTB,UDLED			; change LEDs
		BCF		PORTB,LRLED
		BCF		K_FLAGS,F_RELEASE	; and clear release flag
		GOTO	EOPSC

K_CTRL
		BTFSS	K_FLAGS,F_RELEASE	; if release is not set
		BSF		K_FLAGS,F_CTRL		; then set ctrl
		BTFSC	K_FLAGS,F_RELEASE	; if release is set
		BCF		K_FLAGS,F_CTRL		; then clear ctrl
		BCF		K_FLAGS,F_RELEASE	; also clear release flag
		GOTO	EOPSC

K_CAPS	BTFSS	K_FLAGS,F_RELEASE
		GOTO	TOGGLE_CAPS			; (if not release)
		BCF		K_FLAGS,F_RELEASE	; on release, simply clear the flag
		GOTO	EOPSC				; and ignore the scancode
TOGGLE_CAPS
		MOVLW	1<<F_CAPSLOCK
		XORWF	K_FLAGS,F
		MOVF	K_FLAGS,W
		ANDLW	B'00000110'
		MOVWF	NEXTKBB
		BSF		MYFLAGS,KBTOSEND
		MOVLW	H'ED'
		CALL	SEND_KB
		GOTO	EOPSC

K_F7
		MOVLW	H'02'
		MOVWF	TMP_SC
		GOTO	NORMAL_KEY

K_NUM	BTFSS	K_FLAGS,F_RELEASE
		GOTO	TOGGLE_NUM; (if not release)
		BCF		K_FLAGS,F_RELEASE	; on release, simply clear the flag
		GOTO	EOPSC				; and ignore the scancode
TOGGLE_NUM
		MOVLW	1<<F_NUMLOCK		; get corresponding bit
		XORWF	K_FLAGS,F			; toggle it in FLAGS
		MOVF	K_FLAGS,W
		ANDLW	B'00000110'			; get flags and strip the other bits
		MOVWF	NEXTKBB				; this will be second byte sent
		BSF		MYFLAGS,KBTOSEND
		MOVLW	H'ED'				; ED = SET LEDs
		CALL	SEND_KB
		GOTO	EOPSC

K_SPECIAL
		BSF	K_FLAGS,F_SPECIAL
		GOTO	EOPSC

K_ACK	; send next byte on ACK from keyboard
		BTFSS	MYFLAGS,KBTOSEND	; if we don't have anything more to send,
		GOTO	GOTACK				; modify BYTE4ACK to a "safe" value
		BCF		MYFLAGS,KBTOSEND	; we can clear the flag now
		MOVF	NEXTKBB,W			; get byte to send
		CALL	SEND_KB				; and send it
		GOTO	EOPSC

GOTACK
		MOVLW	H'FF'		; if we get a spurious resend request
		MOVWF	BYTE4ACK	; from keyboard, punish it with a RESET :)
		GOTO	EOPSC

K_RESEND
		MOVF	BYTE4ACK,W
		CALL	SEND_KB
		GOTO	EOPSC

K_SYSRQ						; fooling around
		BTFSC	K_FLAGS,F_RELEASE
		GOTO	EOPSC
		BTFSS	K_FLAGS,F_SHIFT
		GOTO	EOPSC
		MOVLW	1		; prepare for table read (table at 100h)
		MOVWF	PCLATH
		MOVLW	H'33'
		CALL	SCTABLE
		CALL	SENDCHR
		CALL	DELAY_MID
		MOVLW	H'1C'
		CALL	SCTABLE
		CALL	SENDCHR
		CALL	DELAY_MID
		MOVLW	H'1D'
		CALL	SCTABLE
		CALL	SENDCHR
		CALL	DELAY_MID
		MOVLW	H'42'
		CALL	SCTABLE
		CALL	SENDCHR
		CALL	DELAY_MID
		MOVLW	H'49'
		CALL	SCTABLE
		CALL	SENDCHR
		CALL	DELAY_MID
		MOVLW	H'2D'
		CALL	SCTABLE
		CALL	SENDCHR
		CALL	DELAY_MID
		MOVLW	H'44'
		CALL	SCTABLE
		CALL	SENDCHR
		CLRF	PCLATH
		GOTO	EOPSC

K_FAST	; will set fastest typematic rate on ctrl+shift+<key>,
		; where <key> is chosen in special scancodes processing, above
		BTFSC	K_FLAGS,F_RELEASE
		GOTO	EOPSC
		BTFSS	K_FLAGS,F_SHIFT
		GOTO	EOPSC
		BTFSS	K_FLAGS,F_CTRL
		GOTO	EOPSC

		MOVLW   H'00'
		MOVWF   NEXTKBB
		BSF     MYFLAGS,KBTOSEND
		MOVLW   H'F3'
		CALL    SEND_KB
		GOTO	EOPSC

K_NRML	; will set normal typematic rate on ctrl+shift+<key>,
		; where <key> is chosen in special scancodes processing, above
		BTFSC	K_FLAGS,F_RELEASE
		GOTO	EOPSC
		BTFSS	K_FLAGS,F_SHIFT
		GOTO	EOPSC
		BTFSS	K_FLAGS,F_CTRL
		GOTO	EOPSC

		MOVLW   H'2B'
		MOVWF   NEXTKBB
		BSF     MYFLAGS,KBTOSEND
		MOVLW   H'F3'
		CALL    SEND_KB
		GOTO	EOPSC

